﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;

namespace SlowResizeOfGrid
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {

        public Window1()
        {
            InitializeComponent();
            LoadRecords();
        }

        //create an untyped dataset, load it with some records, then bind to the grid
        //
        //when you then resize the form the first time to increase its height, resize is very slow as
        //more records come into view
        private void LoadRecords()
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add("Customers");
            dt.Columns.Add("CustID", typeof(Int32));
            for (int i = 1; i <= 80; i++)
            {
                dt.Columns.Add("Col" + i.ToString(), typeof(DateTime));
            }
            for (int i = 0; i < 100; i++)
            {
                //just some dummy code to create lots of columns
                DateTime now = DateTime.Now;
                dt.Rows.Add(new object[] { i, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                    now, now, now, now, now, now, now, now, now, now, 
                });    
            }
            this.XamDataGrid1.DataSource = ds.Tables[0].DefaultView;
        }

    }
}
